

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void general_all_to_one_reduce(int p, int my_id)
{
  int i, msg;
  int d = ceil(log2(p));
  int mask = 0;
  
  for(i = d-1; i >=0; i--) {
    if((my_id & mask) == 0) {
      msg = (my_id^(1<<i));
      if((my_id&(1 << i)) != 0) {
	printf("Send to process %d\n", msg);
      } else if(msg < p) {
	printf("Receive from process %d\n", msg);
      }
    }
    mask ^= (1 << i);
  }	   	   
}

int main(int argc, char *argv[])
{
  int id, p;

  if(argc < 3) {
    fprintf(stderr, "Give id and number of processes as parameters.\n");
    return -1;
  }

  id = atoi(argv[1]);
  p = atoi(argv[2]);
  
  if (id >= p) {
    fprintf(stderr, "id must be less than number of processes.\n");
    return -1;
  }

  general_all_to_one_reduce(p, id);

  return 0;
}
